var cfg = require('../../cfg.json');
var fs = require('fs');
var http = require('http');
var https = require('https');
var mysql = require('mysql');
var bot = require('coffea')();
const path = require('path');

var allowed = [
  'image/png', 'video/webm'
];

var sql;
function haDC() {
  sql = mysql.createConnection(cfg.mysql);
  sql.connect((err) => {
    if(err) setTimeout(haDC,2000);
  });
  sql.on('error', (err) => {
    if(err.code === 'PROTOCOL_CONNECTION_LOST') haDC();
  });
}
haDC();

cfg.server.forEach((e,i,a) => {
  bot.add({
    "name": e.name,
    "host": e.host,
    "port": e.port,
    "ssl": e.ssl,
    "ssl_allow_invalid": e.ssl_allow_invalid,
    "pass": e.pass,
    "nick": e.nick,
    "username": e.username,
    "realname": e.realname
  });
  console.log("Server "+e.name+" wurden geladen");
});

bot.on('motd', (e) => {
  console.log("motd von "+e.network+" erhalten");
  bot.write('MODE f0ck +B', e.network, (c)=>{}); // Botflag
});

bot.on('message', (e) => {
  var orig = e.message;
  if(orig.match(/https?:\/\/[\w-]+(\.[\w-]+)+\.?(:\d+)?(\/\S*)?/gi)) { // shitpostcatcher
    var tmp = orig.match(/https?:\/\/[\w-]+(\.[\w-]+)+\.?(:\d+)?(\/\S*)?/gi); // get links
    tmp.forEach((entry,i,a) => {
      dl(entry, "./b/"+path.parse(entry).base, (cb) => { // download item
        if(cb.status === true) {
          var tmpuser = getUser(e.user.getNick(), e.network);
          sql.query("insert into `f0ck`.`items` (`src`,`dest`,`username`,`userchannel`,`usernetwork`,`stamp`,`active`) values (?,?,?,?,?,?,?)", [
            entry,
            "./b/"+path.parse(entry).base,
            tmpuser['nick'],
            e.channel.getName(),
            e.network,
            new Date().getTime(),
            0
          ]).on('end', () => {
            e.reply(cb.msg+" for "+tmpuser['nick']+" ("+tmpuser['username']+"@"+tmpuser['hostname']+")");
          }).on('error', (msg) => {
            e.reply(msg);
          });
        }
        else
          e.reply(cb.msg);
      });
    });
  }
  else if(orig.match(/^\.user/)) { // (debug) get userinfos
    var tmp = getUser(e.user.getNick(), e.network);
    setTimeout(()=>{ e.reply(tmp); }, 1500);
  }
  else if(orig.match(/^\.del/) && e.channel.getName().toString() == "#f0ck") {
    sql.query("truncate table `f0ck`.`items`")
      .on('end', () => {
        e.reply("database truncated");
      }).on('error', (msg) => {
        e.reply(msg);
      });
  }
});

var getUser = (u, n) => {
  bot.whois(u, n, (fn)=>{ }); // send whois
  var start = Date.now();
  while(Date.now() < start + 1000) {} // block script for catch whois
  return bot.getUser(u, n);
};

var dl = (url, dest, cb) => {
  var file = fs.createWriteStream(dest);
  var request = (url.match(/^https/)?https:http).get(url, (response) => {
    try {
      if(allowed.indexOf(response.headers['content-type']) != -1) {
        checkRepost(url, (cbcr) => {
          if(cbcr) {
            response.pipe(file);
            file.on('finish', () => {
              file.close();
              cb({'status':true, 'msg':'downloaded '+dest});
            });
            file.on('error', (err) => {
              fs.unlink(dest);
              file.close();
              cb({'status':false, 'msg':err.message});
            });
          }
          else {
            cb({'status':false, 'msg':'repost motherf0cker'});
          }
        });
      }
      else {
        cb({'status':false, 'msg':'f0ck you'});
      }
    }
    catch(ex) {
      e.reply(ex);
    }
  });
};

var checkRepost = (url, cbcr) => {
  sql.query("select count(*) as count from `f0ck`.`items` where `src` = ?", url, (err, rows, fields) => {
    cbcr((rows[0].count == 0)?true:false);
  });
};